const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const highlights = sequelize.define(
    'highlights',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

is_archived: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  highlights.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
















    db.highlights.hasMany(db.highlight_items, {
      as: 'highlight_items_highlight',
      foreignKey: {
          name: 'highlightId',
      },
      constraints: false,
    });














//end loop



    db.highlights.belongsTo(db.users, {
      as: 'owner',
      foreignKey: {
        name: 'ownerId',
      },
      constraints: false,
    });



    db.highlights.hasMany(db.file, {
      as: 'cover_image',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.highlights.getTableName(),
        belongsToColumn: 'cover_image',
      },
    });


    db.highlights.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.highlights.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return highlights;
};


